Option Strict Off
Option Explicit On

'Drawing library imports
Imports System
Imports System.Windows.Forms
Imports System.Drawing
Imports System.Drawing.Drawing2D
Imports System.Drawing.Text
Imports System.Drawing.Imaging

Friend Class Form1
	Inherits System.Windows.Forms.Form
	'Set this to "1" if making an exe or "0" if debugging
	'(so that the full paths are included in the declare statements)
#Const EXE_BUILD = 1
	
#If EXE_BUILD Then
	Private Declare Function ECIO_GetDLLVersion Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Open Lib "ECIO_api.dll" (ByVal index As Integer, ByRef pVID_PID As Byte) As Integer
    Private Declare Function ECIO_Close Lib "ECIO_api.dll" () As Integer
    Private Declare Function ECIO_Transmit Lib "ECIO_api.dll" (ByRef pDataOut As Byte, ByVal dwLenOut As Integer, ByRef pActualLenOut As Integer, ByRef pDataIn As Byte, ByVal dwExpectedLenIn As Integer, ByRef pActualLenIn As Integer, ByVal dwTimeout As Integer) As Integer
    Private Declare Function ECIO_GetDeviceCount Lib "ECIO_api.dll" (ByRef pVID_PID As Byte) As Integer
#End If

    'Global variables
	Private sID(20) As Byte
    Private Log_Enable As Byte
    Const MAX_X As Short = 600
    Private ADC0Data(MAX_X) As Byte
    Private ADC1Data(MAX_X) As Byte
    Private bm As New Bitmap("back.jpg")
    Private x As Integer
	
	Private Sub Form1_Load(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles MyBase.Load

        'Define which USB Slave device we are talking to
		sID(0) = Asc("v")
		sID(1) = Asc("i")
		sID(2) = Asc("d")
		sID(3) = Asc("_")
		sID(4) = Asc("1")
		sID(5) = Asc("2")
		sID(6) = Asc("b")
		sID(7) = Asc("f")
		sID(8) = Asc("&")
		sID(9) = Asc("p")
		sID(10) = Asc("i")
		sID(11) = Asc("d")
		sID(12) = Asc("_")
        sID(13) = Asc("f")
		sID(14) = Asc("0")
        sID(15) = Asc("4")
		sID(16) = Asc("0")
		sID(17) = 0

        'Initialise logging control variable
        Log_Enable = 0

        'Initialise the output paint style
        Me.SetStyle(ControlStyles.ResizeRedraw, True)
        Me.SetStyle(ControlStyles.DoubleBuffer, True)
        Me.SetStyle(ControlStyles.AllPaintingInWmPaint, True)

	End Sub
	
	
	Private Sub Form1_FormClosed(ByVal eventSender As System.Object, ByVal eventArgs As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        'Make sure the connection is closed
        ECIO_Close()

	End Sub
	

    Private Sub Stopbut_Click(ByVal eventSender As System.Object, ByVal eventArgs As System.EventArgs) Handles Stopbut.Click

        'Stop logging loop
        Log_Enable = 0

        'Change the state of the buttons
        Start.Enabled = True
        Stopbut.Enabled = False

    End Sub

    Private Sub output_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles output.Paint

        'Create a hidden image to write the plot data to
        Dim new_bm As New Bitmap(bm)
        Dim gr As Graphics = Graphics.FromImage(new_bm)

        'Draw display
        For x = 0 To MAX_X

            'Draw plot data onto hidden image
            gr.DrawRectangle(Pens.Red, x:=x, y:=ADC0Data(x), Width:=1, Height:=1)
            gr.DrawRectangle(Pens.Green, x:=x, y:=ADC1Data(x), Width:=1, Height:=1)

        Next x

        'Output hidden image to display
        e.Graphics.DrawImage(new_bm, 0, 0, 600, 260)

    End Sub

    Private Sub Start_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Start.Click

        'Define a few variables
        Dim lRetVal As Integer
        Dim bDataOut(32) As Byte
        Dim bDataIn(128) As Byte
        Dim xPix As Integer
        Dim nTxDataCnt As Integer
        Dim nRxDataCnt As Integer

        'Open connection to the USB Slave
        lRetVal = ECIO_Open(0, sID(0))
        Text1.Text = "Open = " & lRetVal & vbCrLf & Text1.Text

        'Change the state of the buttons
        Start.Enabled = False
        Stopbut.Enabled = True

        'Initialise loop control variable 
        Log_Enable = 1

        'Main trace loop
        Do Until Log_Enable = 0

            'Check for the stop button being pressed
            System.Windows.Forms.Application.DoEvents()

            'Shift ADC data to next position in the buffer
            For x = 0 To MAX_X - 1

                xPix = MAX_X - x

                ADC0Data(xPix) = ADC0Data(xPix - 1)
                ADC1Data(xPix) = ADC1Data(xPix - 1)

            Next x

            'Setup the sample ADC0 command
            bDataOut(0) = 19
            bDataOut(1) = 0

            'Send out the sample ADC0 command
            lRetVal = ECIO_Transmit(bDataOut(0), 2, nTxDataCnt, bDataIn(0), 2, nRxDataCnt, 50)

            'Add new ADC0 data byte to the start of the buffer
            ADC0Data(0) = 255 - bDataIn(0)

            'Setup the sample ADC1 command
            bDataOut(0) = 20
            bDataOut(1) = 0

            'Send out the sample ADC1 command
            lRetVal = ECIO_Transmit(bDataOut(0), 2, nTxDataCnt, bDataIn(0), 2, nRxDataCnt, 50)

            'Add new ADC1 data byte to the start of the buffer
            ADC1Data(0) = 255 - bDataIn(0)

            'Update the display
            output.Refresh()

        Loop

        Text1.Text = "Logging Stopped" & vbCrLf & Text1.Text

        'Close the connection to the device
        lRetVal = ECIO_Close
        Text1.Text = "Close = " & lRetVal & vbCrLf & Text1.Text

    End Sub

End Class